 type Predicate = Pred of string
 type Term =  Var of string
		   |  Int of int
		   |  String of string

 type Expression = Terminal of Term
		   | Plus of (Expression * Expression)
		   | Minus of (Expression * Expression)
		   
 type TermList = Term list

 type Literal = Predicate * TermList
 type LitList  =  Literal list

 type Filter = LessThan of  Term*Term 
	       | GreaterThan of Term*Term
	       | LessThanEqual of Term*Term
	       | FilterEqual of Term*Term

 type FilterList = Filter list 

 type Function = FnEqual of Term * Expression

 type FunctionList = Function list
	
 type Clause  =  Fact of Literal
		| Query of Literal
		| Rule of  Literal * LitList * LitList* FilterList * FunctionList

 type ProgBody = Progbody of Clause list	
		   
(* used only during parsing *) 

 type PreProcess = Preprocess of string list
  
 type ParseLiteral = PosLiteral of Literal
                   | NegLiteral of Literal
				   | FunctionLiteral of Function
		           | FilterLiteral of Filter
 
(* TODO: clean this up to reflect that facts and queries have no negations *)
(* something like PFact of LiteralPredicate * TermList *)

 type ParseClause = PFact of Literal
		| PQuery of Literal
		| PRule of Literal * (ParseLiteral List)

 type ParseProgBody = Parseprogbody of ParseClause list
              
 type Prog = Program of PreProcess * ParseProgBody
 