 type Predicate = Pred of string
 type Term =  Var of string
 type TermList = Term list


 type ZeroaryPredicate = Predicate
 
 type BaseUnaryPredicate = BaseUnary of Predicate * Term
 type PositiveUnaryPredicate = PosUp of BaseUnaryPredicate
 type NegativeUnaryPredicate = NegUp of BaseUnaryPredicate
 
 type UnaryPredicate  = PUP of PositiveUnaryPredicate 
						|NUP of NegativeUnaryPredicate
 
 type BaseLiteral  = Base of Predicate * TermList
 type PositiveLiteral = PosLit of BaseLiteral
 type NegativeLiteral = NegLit of BaseLiteral
 
 type Literal  = PosLiteral of PositiveLiteral
				|NegLiteral of NegativeLiteral
				|PosUnary   of PositiveUnaryPredicate
				|NegUnary   of NegativeUnaryPredicate
				|Zeroary    of ZeroaryPredicate
				
 type PosLitList = PositiveLiteral list
 type NegLitList = NegativeLiteral list

 type Query  =    BaseQuery of PositiveLiteral
				| ORQuery of Query *  Query
				| AfterQuery of Query * Query
		
 type Clause  =   Edb of PositiveUnaryPredicate
				| Query of Query
				| Rule of  PositiveLiteral * PosLitList * NegLitList
				| NewRule of (PositiveUnaryPredicate List ) * ZeroaryPredicate
				| NextRule of (PositiveUnaryPredicate List) * (NegativeUnaryPredicate List) * PosLitList * NegLitList
		
 type Program = ClauseList of Clause list	
 
 //type Program = (ZeroaryPredicate List) * (PositiveUnaryPredicate List)
		   
(* used only during parsing 

 type PreProcess = Preprocess of string list
*)
  
 
(* TODO: clean this up to reflect that facts and queries have no negations *)
(* something like PFact of LiteralPredicate * TermList *)

 type P_Clause = PEdb of PositiveUnaryPredicate
		| PQuery of Query
		| PRule of PositiveLiteral * (Literal List)
		| PNewRule of (PositiveUnaryPredicate List) * ZeroaryPredicate
		| PNextRule of (UnaryPredicate List) * (Literal List)

 
 type P_Preprocess = Filenames of (string list)
 type Prog = PProg of P_Preprocess *( P_Clause List)
 
