@if "%_echo%"=="" echo off

setlocal
set srct=Translator
set srci=Interpreter
set cwd=%CD%

REM ------------------------------------------------------------------
ECHO Building Translator...
cd %srct%

ECHO Building Translator lexer...
fslex -o lex.fs lex.fsl
if ERRORLEVEL 1 goto Exit
ECHO Translator lexer built.

ECHO Building Translator parser...
fsyacc -o pars.fs pars.fsy
if ERRORLEVEL 1 goto Exit
ECHO Translator parser built.

ECHO Building Translator sources...
fsc -r FSharp.PowerPack --mlcompatibility -o translate.exe ast.fs pars.fsi pars.fs lex.fs printutils.fs transformparseoutput.fs translatetemporaldatalog.fs translaterestrictedtemporaldatalog.fs main.fs
if ERRORLEVEL 1 goto Exit
ECHO Translator sources built.

cd %cwd%
move %srct%\translate.exe .
	
REM ------------------------------------------------------------------
ECHO Building Interpreter...
cd %srci%

ECHO Building Interpreter lexer...
fslex -o lex.fs lex.fsl
if ERRORLEVEL 1 goto Exit
ECHO Interpreter lexer built.

ECHO Building Interpreter parser...
fsyacc -o pars.fs pars.fsy
if ERRORLEVEL 1 goto Exit
ECHO Interpreter parser built.

ECHO Building Interpreter sources...
fsc -r FSharp.PowerPack --mlcompatibility -o interpret.exe ast.fs print.fs typecheck.fs ninterp.fs output.fs pars.fsi pars.fs lex.fs read.fs main.fs
if ERRORLEVEL 1 goto Exit
ECHO Interpreter sources built.

cd %cwd%
move %srci%\interpret.exe .
	
ECHO ------------------------------------------------------------------
ECHO Run:

ECHO translate.exe inputfile translatedfile
ECHO interpret.exe translatedfile

:Exit
endlocal

exit /b %ERRORLEVEL%

